Android River is a modern Android 2.2 news app. It's now version 1.15.

Android River has the following features:
- Read RSS 1.0, RSS 2.0 and ATOM 1.0.
- Create your own custom River of News out of feeds.
- Read RiverJs format.
- Read OPML and display them in an outline.
- Download and play Podcast with a custom made podcast player.
- Create RSS feeds out of Google News, Kayak.com deals and Craigslist.
- Feature a frequently updated sources of feeds to subscribe to.
- There is no login required to use any of the functionality.
- There are no ads.
- It is super fast.
- It is efficient with data/battery usage.
- It has the awesome Holo theme applied even from Android 2.2.
- Tweets links easily or read articles for later (great integration with Pocket)

The website for this project is at http://rivers.silverkeytech.com. Android River can be downloaded at Google Store http://goo.gl/kShgp.

The mailing list for this project is at groups.google.com/group/news-and-protocols.

This code is licensed under GPL version 3. Please read license.txt.

I develop Android Rivers using <a href="http://kotlin.jetbrains.org/">Kotlin programming language</a>. It might not be
obvious that this is Kotlin project since there are a lot of Java code in the project. Most of these Java code are open source
libraries that Android Rivers include in source form by necessity. Most of the Kotlin code is located at NewsEngine module and
com.silverkeytech.android_rivers package at the main project.

By reading Android Rivers source code, you will learn about:

* Using SQLite database.
* High performance XML parsing.
* High performance JSON parsing.
* Implementing a media player.
* Writing Android Service.
* Accessing Android Clipboard.
* Fragments.
* Implementing Holo theme in Android 2.2 above.
* Using Library modules.
* First class Outliner UI support.
* Asynchronous operations.
* Managing file system.
* Creating custom dialogs.
* Implementing Sliding Menu.
* Asynchronous HTTP calls.
* Integrating Android Java library.
* Implementing Arabic language support.
* Implement EventBus.

Open Source Library used:
* [ActionBar Sherlock](http://actionbarsherlock.com/) - [Apache License 2.0](http://www.apache.org/licenses/LICENSE-2.0)
* [Tree-view-list-android](http://code.google.com/p/tree-view-list-android/)
* [google-gson](http://code.google.com/p/google-gson/) - [Apache License 2.0](http://www.apache.org/licenses/LICENSE-2.0)
* [http-request](https://github.com/kevinsawicki/http-request)
* [Simple Java Xml Parser](https://github.com/thebuzzmedia/simple-java-xml-parser)
* [Scribe-Java](https://github.com/fernandezpablo85/scribe-java)
* [HoloEverywhere](https://github.com/ChristopheVersieux/HoloEverywhere)